# simple-git-hooks


![](https://img.shields.io/badge/dependencies-zero-green)

A tool, that lets you easily manage git hooks

> The package was recently renamed from `simple-pre-commit`, see **github releases** for `simple-pre-commit` documentation


## Usage

### Add simple-git-hooks to the project:

1. Install the simple-git-hooks as dev dependency 
   
   ```sh
   npm install simple-git-hooks --save-dev
   ```

2. Add the `simple-git-hooks` to your `package.json`. Fill it with git hooks and corresponding commands. 

    For example:
   
   ```json
     "simple-git-hooks": {
       "pre-commit": "npx lint-staged",
       "pre-push": "cd ../../ && npm run format"
     }     
   ```
    
    This configuration is going to run all linters on every `commit` and formatter on `push`
    
   > There are more ways to configure the package. Check out [additional configuration](#Additional configuration options)
    
3. Run the CLI script to update the git hooks with commands from config

   ```sh
   npx simple-git-hooks
   ```
    
Now all git hooks are created

### Update git hooks command

1. Change the configuration

2. Run `npx simple-git-hooks` **from root of your project**

Note that you should manually run `npx simple-git-hooks` **every time you change the command**


### Additional configuration options

You can also add the `.simple-git-hooks.json` or `simple-git-hooks.json` to the project and write the configuration inside it

That way, `.simple-git-hooks.json` or `simple-git-hooks.json` should look like this and `package.json` may not have `simple-git-hooks` configuration inside it

```json
{ 
    "pre-commit":"npx lint staged",
    "pre-push": "cd ../../ && npm run format"
}
```

### Uninstall pre-commit-hook

> Uninstallation will remove all existing git hooks

```sh
npm uninstall --save-dev simple-git-hooks
```
